def intersect(r1, r2):
    ix = max(r1[0], r2[0])
    iy = max(r1[1], r2[1])
    iw = min(r1[0] + r1[2], r2[0] + r2[2]) - ix
    ih = min(r1[1] + r1[3], r2[1] + r2[3]) - iy
    if iw < 0: iw = 0
    if ih < 0: ih = 0
    return [ix, iy, iw, ih]

arr = []
k, n = map(int, input().split())
arr.append([0, 0, k, k])
x, y = 0, 0
for nn in range(n):
    d, a_str = input().split()
    a = int(a_str)
    if d == "N":
        arr.append([x, y + k, k, a])
        y += a
    elif d == "S":
        arr.append([x, y - a, k, a])
        y -= a
    elif d == "E":
        arr.append([x + k, y, a, k])
        x += a
    else:
        arr.append([x - a, y, a, k])
        x -= a
area = 0
coords = []
for i in range(len(arr)):
    area += arr[i][2] * arr[i][3]
    iarr = []
    for j in range(i + 1, len(arr)):
        rect = intersect(arr[i], arr[j])
        for xx in range(rect[0], rect[0]+rect[2]):
            for yy in range(rect[1], rect[1] + rect[3]):
                s = str(xx) + "/" + str(yy)
                if s not in iarr: iarr.append(s)
    area -= len(iarr)
print(area)